<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.output;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.PrintWriter;<a name="line.36"></a>
<FONT color="green">037</FONT>    <a name="line.37"></a>
<FONT color="green">038</FONT>    import ch.javasoft.metabolic.MetabolicNetwork;<a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.metabolic.Reaction;<a name="line.39"></a>
<FONT color="green">040</FONT>    <a name="line.40"></a>
<FONT color="green">041</FONT>    /**<a name="line.41"></a>
<FONT color="green">042</FONT>     * The &lt;tt&gt;MatlabOutputFormatter&lt;/tt&gt; writes the efms to a textfile which can<a name="line.42"></a>
<FONT color="green">043</FONT>     * be run as a matlab script. The script re-establishes the efms as matlab  <a name="line.43"></a>
<FONT color="green">044</FONT>     * matrices.<a name="line.44"></a>
<FONT color="green">045</FONT>     */<a name="line.45"></a>
<FONT color="green">046</FONT>    public class MatlabOutputFormatter implements EfmOutputFormatter&lt;PrintWriter&gt; {<a name="line.46"></a>
<FONT color="green">047</FONT>            <a name="line.47"></a>
<FONT color="green">048</FONT>            private boolean formatAsDouble(EfmOutputCallback cb) {<a name="line.48"></a>
<FONT color="green">049</FONT>                    return cb.getGranularity() == CallbackGranularity.DoubleUncompressed;<a name="line.49"></a>
<FONT color="green">050</FONT>            }<a name="line.50"></a>
<FONT color="green">051</FONT>            protected String getVariableName() {<a name="line.51"></a>
<FONT color="green">052</FONT>                    return "efmout";<a name="line.52"></a>
<FONT color="green">053</FONT>            }<a name="line.53"></a>
<FONT color="green">054</FONT>            public void formatHeader(EfmOutputCallback cb, PrintWriter writer, EfmOutputEvent evt) {<a name="line.54"></a>
<FONT color="green">055</FONT>                    MetabolicNetwork net = Util.getNetworkUncompressedIfNeeded(cb.getGranularity(), evt);<a name="line.55"></a>
<FONT color="green">056</FONT>                    <a name="line.56"></a>
<FONT color="green">057</FONT>                    // print the reaction names<a name="line.57"></a>
<FONT color="green">058</FONT>                    writer.print(getVariableName() + ".reactions = {");<a name="line.58"></a>
<FONT color="green">059</FONT>                    boolean first = true;<a name="line.59"></a>
<FONT color="green">060</FONT>                    for (Reaction reac : net.getReactions()) {<a name="line.60"></a>
<FONT color="green">061</FONT>                            if (first) first = false;<a name="line.61"></a>
<FONT color="green">062</FONT>                            else writer.print(", ");<a name="line.62"></a>
<FONT color="green">063</FONT>                            writer.print("'" + reac.getFullName() + "'");                   <a name="line.63"></a>
<FONT color="green">064</FONT>                    }<a name="line.64"></a>
<FONT color="green">065</FONT>                    writer.println("};");<a name="line.65"></a>
<FONT color="green">066</FONT>                    <a name="line.66"></a>
<FONT color="green">067</FONT>                    if (formatAsDouble(cb)) {<a name="line.67"></a>
<FONT color="green">068</FONT>                            writer.println(getVariableName() + ".efm = sparse(0, " + net.getReactions().length() + ");");                   <a name="line.68"></a>
<FONT color="green">069</FONT>                    }<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>    <a name="line.71"></a>
<FONT color="green">072</FONT>            public void formatEfmHeader(EfmOutputCallback cb, PrintWriter writer, EfmOutputEvent evt, long efmIndex) {<a name="line.72"></a>
<FONT color="green">073</FONT>                    if (formatAsDouble(cb)) {<a name="line.73"></a>
<FONT color="green">074</FONT>                            writer.println("% " + getVariableName() + ".efm(" + (efmIndex + 1) + ",:)");<a name="line.74"></a>
<FONT color="green">075</FONT>                    }<a name="line.75"></a>
<FONT color="green">076</FONT>                    else {<a name="line.76"></a>
<FONT color="green">077</FONT>                            writer.print(getVariableName() + ".efm(" + (efmIndex + 1) + ",:) = ('");<a name="line.77"></a>
<FONT color="green">078</FONT>                    }<a name="line.78"></a>
<FONT color="green">079</FONT>            }<a name="line.79"></a>
<FONT color="green">080</FONT>    <a name="line.80"></a>
<FONT color="green">081</FONT>            public void formatEfmValue(EfmOutputCallback cb, PrintWriter writer, EfmOutputEvent evt, long efmIndex, int valueIndex, Number value) {<a name="line.81"></a>
<FONT color="green">082</FONT>                    final double dvalue = value.doubleValue();<a name="line.82"></a>
<FONT color="green">083</FONT>                    if (formatAsDouble(cb)) {<a name="line.83"></a>
<FONT color="green">084</FONT>                            if (dvalue != 0d) {<a name="line.84"></a>
<FONT color="green">085</FONT>                                    writer.print(getVariableName() + ".efm(" + (efmIndex + 1) + ", " + (valueIndex + 1) + ")=");<a name="line.85"></a>
<FONT color="green">086</FONT>                                    writer.print(value);<a name="line.86"></a>
<FONT color="green">087</FONT>                                    writer.print("; ");<a name="line.87"></a>
<FONT color="green">088</FONT>                            }<a name="line.88"></a>
<FONT color="green">089</FONT>                    }<a name="line.89"></a>
<FONT color="green">090</FONT>                    else {<a name="line.90"></a>
<FONT color="green">091</FONT>                            writer.print(dvalue == 0d ? '0' : '1');                 <a name="line.91"></a>
<FONT color="green">092</FONT>                    }<a name="line.92"></a>
<FONT color="green">093</FONT>            }<a name="line.93"></a>
<FONT color="green">094</FONT>    <a name="line.94"></a>
<FONT color="green">095</FONT>            public void formatEfmFooter(EfmOutputCallback cb, PrintWriter writer, EfmOutputEvent evt, long efmIndex) {<a name="line.95"></a>
<FONT color="green">096</FONT>                    if (formatAsDouble(cb)) {<a name="line.96"></a>
<FONT color="green">097</FONT>                            writer.println();<a name="line.97"></a>
<FONT color="green">098</FONT>                    }<a name="line.98"></a>
<FONT color="green">099</FONT>                    else {<a name="line.99"></a>
<FONT color="green">100</FONT>                            writer.println("' == '1');");                   <a name="line.100"></a>
<FONT color="green">101</FONT>                    }<a name="line.101"></a>
<FONT color="green">102</FONT>            }<a name="line.102"></a>
<FONT color="green">103</FONT>    <a name="line.103"></a>
<FONT color="green">104</FONT>            public void formatFooter(EfmOutputCallback cb, PrintWriter writer, EfmOutputEvent evt, long countEfms) {<a name="line.104"></a>
<FONT color="green">105</FONT>                    writer.println("% " + countEfms + " elementary modes.");                <a name="line.105"></a>
<FONT color="green">106</FONT>            }<a name="line.106"></a>
<FONT color="green">107</FONT>    <a name="line.107"></a>
<FONT color="green">108</FONT>            public boolean isEfmValueIterationNeeded(EfmOutputCallback cb) {<a name="line.108"></a>
<FONT color="green">109</FONT>                    return true;<a name="line.109"></a>
<FONT color="green">110</FONT>            }<a name="line.110"></a>
<FONT color="green">111</FONT>    }<a name="line.111"></a>




























































</PRE>
</BODY>
</HTML>
